package org.ezunit.evaluation;

import java.io.IOException;
import java.util.List;
import java.util.Set;

import org.ezunit.evaluation.MatrixDataReader.Result;
import org.ezunit.evaluation.MatrixDataReader.Test;
import org.ezunit.evaluation.MatrixDataReader.UUT;

public class Usage {

	/**
	 * @param args
	 * @throws IOException 
	 */
	public static void main( String[] args ) throws IOException {
		Result input = MatrixDataReader.getTestsAndUUTsFromFile( "path/to/file" );
		Result fcmInput = MatrixDataReader.getFCM( input );
		
		Set<Set<Test>> bdm = BDM.getBlocks( fcmInput );
		Set<WKBlock<UUT, Test>> wkh = new WK().getBlocksH( fcmInput );
		Set<WKBlock<Test, UUT>> wkv = new WK().getBlocksV( fcmInput );
		Set<Set<Test>> jones = new Jones().getBlocks( input );
		
		System.out.println( "BDM: " + bdm.size() + " partitions" );
		int i = 0;
		
		for ( Set<Test> part : bdm )
			System.out.println( "  " + i++ + ": " + part.size() + " tests" );
		
		System.out.println();
		System.out.println( "WKH: " + wkh.size() + " partitions" );
		i = 0;
		
		for ( WKBlock<UUT, Test> block : wkh ) {
			System.out.println( "  " + i++ + ": dirt = " + block.dirt.size() + ", subblocks = " + block.subBlocks.size() );
			
			for ( List<UUT> subblock : block.subBlocks )
				System.out.println( "    subblock: " + subblock.size() );
		}
			
		System.out.println();
		System.out.println( "WKV: " + wkv.size() + " partitions" );
		i = 0;
		
		for ( WKBlock<Test, UUT> block : wkv ) {
			System.out.println( "  " + i++ + ": dirt = " + block.dirt.size() + ", subblocks = " + block.subBlocks.size() );
			
			for ( List<Test> subblock : block.subBlocks )
				System.out.println( "    subblock: " + subblock.size() );
		}
		
		System.out.println();
		System.out.println( "Jones: " + jones.size() + " partitions" );
		i = 0;
		
		for ( Set<Test> part : jones )
			System.out.println( "  " + i++ + ": " + part.size() + " tests" );
	}
}
